<template>
  <v-app>
    <v-dialog v-model="dialogBizAccount" width="350">
      <v-card>
        <v-spacer></v-spacer>
        <v-toolbar-items style="padding-right:10px;">
          <v-btn icon @click="dialogBizAccount = false">
            <v-icon color="#6a7d69">mdi-close</v-icon>
          </v-btn>
        </v-toolbar-items>
        <v-layout class="justify-center">
          <div style="color:black;">
            <img :src="images.bizaccount" style="width:220px;" />
          </div>
        </v-layout>
        <v-card-title
          class="justify-center"
          style="color:#6a7d69; font-size:18px;"
          >BUSINESS ACCOUNT</v-card-title
        >
        <div class="dialogBBL">
          <strong style="color:#6a7d69;">STEP 1 :</strong> Sign up business
          account by following step from
          <a
            style="color:#6a7d69;"
            href="/User_Manual_Business.pdf"
            target="blank"
            >manual</a
          ><br />
          <strong style="color:#6a7d69;">STEP 2 :</strong> Create position
          'admin-ipay'<br />
          <strong style="color:#6a7d69;">STEP 3 :</strong> Add employee in this
          position
        </div>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogloader" persistent content-class="elevation-0">
      <v-layout class="justify-center">
        <v-card color="transparent" class="elevation-0">
          <self-building-square-spinner
            :animation-duration="2000"
            :size="70"
            color="white"
          />
        </v-card>
      </v-layout>
    </v-dialog>

    <v-content
      style="background-color: #d2e7c2;background-repeat: no-repeat;background-size: cover;"
      :style="{
        backgroundImage: 'url(' + require('@/assets/vector-2.png') + ')'
      }"
    >
      <v-container fill-height>
        <v-card
          class="mx-auto my-12 rounded-card"
          elevation="2"
          width="100%"
          height="100%"
        >
          <v-layout>
            <v-flex md7 xs7>
              <div>
                <img
                  :src="images.logoinet"
                  style="padding-left:10px;padding-top:10px"
                />
              </div>
              <center><img :src="images.computer" class="img-com" /></center>
            </v-flex>

            <v-flex md5 xs5>
              <span class="text-title">Login for Admin</span>
              <span class="text-subtitle">
                Login with your data that you entered during your registration.
              </span>

              <div v-if="!mobileView">
                <v-card-text class="login layoutlogin loginicon" color="white">
                  <span class="text">Username</span>
                  <v-text-field
                    outline
                    placeholder="Username"
                    name="username"
                    v-model="username"
                    ref="username"
                    :rules="[() => !!username || 'This field is required']"
                  ></v-text-field>
                  <span class="text">Password</span>
                  <v-text-field
                    outline
                    placeholder="Password"
                    v-model="password"
                    ref="password"
                    :append-icon="showUsername ? 'mdi-eye' : 'mdi-eye-off'"
                    :type="showUsername ? 'text' : 'password'"
                    :rules="[() => !!password || 'This field is required']"
                    @click:append="showUsername = !showUsername"
                  ></v-text-field>
                </v-card-text>

                <div class="layoutlogin" style="margin-top:5px">
                  <v-layout>
                    <v-flex md6 xs6> </v-flex>
                    <v-flex md6 xs6>
                      <a
                        href="https://one.th/type_forgot_password"
                        target="_blank"
                        color="#efdbd4"
                        class="forgotpassword"
                        >Forgot password?
                      </a>
                    </v-flex></v-layout
                  >
                </div>

                <v-card-actions class="layoutlogin">
                  <v-btn
                    class="loginbtn white--text"
                    style="margin:0px 10px; background-color:#3A8300; box-shadow: 1px 1px 10px 1px rgb(172, 185, 172)"
                    @click="login"
                    round
                    block
                    >Login
                  </v-btn>
                </v-card-actions>

                <div class="layoutlogin">
                  <p
                    class="text-normal"
                    style="margin-bottom: 16px;font-family: Sarabun, sans-serif;"
                  >
                    Don't have an account?
                    <a
                      href="https://one.th/register"
                      target="_blank"
                      class="text-signup"
                      >Sign up</a
                    >
                  </p>
                </div>
              </div>
            </v-flex>
          </v-layout>

          <!-- --------------------------- mobileView ------------------------------ -->
          <div v-if="mobileView" style="margin: 20px;">
            <span class="text">Username</span>
            <v-text-field
              outline
              placeholder="Username"
              name="username"
              v-model="username"
              ref="username"
              :rules="[() => !!username || 'This field is required']"
            ></v-text-field>
            <span class="text">Password</span>
            <v-text-field
              outline
              placeholder="Password"
              v-model="password"
              ref="password"
              :append-icon="showUsername ? 'mdi-eye' : 'mdi-eye-off'"
              :type="showUsername ? 'text' : 'password'"
              :rules="[() => !!password || 'This field is required']"
              @click:append="showUsername = !showUsername"
            ></v-text-field>

            <div style="margin-top:5px">
              <v-layout>
                <v-flex md6 xs6> </v-flex>
                <v-flex md6 xs6>
                  <a
                    href="https://one.th/type_forgot_password"
                    target="_blank"
                    color="#efdbd4"
                    class="forgotpassword"
                    >Forgot password?
                  </a>
                </v-flex></v-layout
              >
            </div>

            <v-card-actions>
              <v-btn
                class="loginbtn white--text"
                style="margin:0px 10px; background-color:#3A8300; box-shadow: 1px 1px 10px 1px rgb(172, 185, 172)"
                @click="login"
                round
                block
                >Login
              </v-btn>
            </v-card-actions>

            <div>
              <p
                class="text-normal"
                style="margin-bottom: 16px;font-family: Sarabun, sans-serif;"
              >
                Don't have an account?
                <a
                  href="https://one.th/register"
                  target="_blank"
                  class="text-signup"
                  >Sign up</a
                >
              </p>
            </div>
          </div>
        </v-card>
      </v-container>
    </v-content>
  </v-app>
</template>

<script>
import { sync } from "vuex-pathify";
import { TextEncoder } from "text-encoding";
import { SelfBuildingSquareSpinner } from "epic-spinners";
import Swal from "sweetalert2";

if (!window["TextEncoder"]) {
  window["TextEncoder"] = TextEncoder;
}
export default {
  components: {
    SelfBuildingSquareSpinner
  },
  data() {
    return {
      dialogBizAccount: false,
      dialogloader: false,
      mobileView: false,
      // typeTaxid: 'citizen',
      showUsername: false,
      username: "",
      password: "",
      getname: "",
      firstname: "",
      images: {
        logo: require("../assets/inetlogo.png"),
        bizaccount: require("../assets/bizaccount.png"),
        logoinet: require("../assets/inet.png"),
        computer: require("../assets/computer.png")
      },
      a: ""
    };
  },
  methods: {
    clearCookie() {
      this.$cookies.keys().forEach(key => {
        if (key !== "checkchkbox") {
          let keyremove = key;
          this.$cookies.remove(keyremove);
        }
      });
    },
    checkField() {
      this.formHasErrors = false;
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) this.formHasErrors = true;
        this.$refs[f].validate(true);
      });
    },
    async login() {
      this.checkField();
      if (this.formHasErrors === false) {
        try {
          // if (this.typeTaxid === 'citizen') {
          // const taxIDhash = await this.digestMessage(this.taxid)
          this.dialogloader = true;
          let user_pass = this.username + " " + this.password;
          let buff = new Buffer(user_pass);
          let base64data = buff.toString("base64");
          var { data } = await this.axios.post(
            process.env.VUE_APP_APIHOST + "/login_admin",
            {
              source: base64data
            }
          );
          // console.log(data);
          if (data.status === "Success") {
            this.dialogloader = false;
            this.$cookies.set(
              "firstlastTH",
              data.first_name + " " + data.last_name
            );
            this.$cookies.set("bizNameTH", data.company_name_th);
            // this.$cookies.set("nameTH", data.name_th);
            this.$session.start();
            this.$cookies.set("role", "Admin");
            this.$cookies.set("token", data.token);
            this.$cookies.set("createdBy", data.createBy);
            this.$router.push("/maindashboard");
            localStorage.setItem("image", data.pic);
          } else {
            Swal.fire({
              title: "Login Failed",
              text: data.status,
              icon: "error",
              showConfirmButton: false,
              timer: 3000
            });
            this.dialogloader = false;
          }
        } catch (error) {
          console.log(error.message);
        }
      } else {
        this.checkField();
      }
    },
    async digestMessage(salt) {
      const msgUint8 = new TextEncoder().encode(salt); // encode as (utf-8) Uint8Array
      const hashBuffer = await window.crypto.subtle.digest("SHA-256", msgUint8); // hash the message
      const hashArray = Array.from(new Uint8Array(hashBuffer)); // convert buffer to byte array
      const hashHex = hashArray
        .map(b => b.toString(16).padStart(2, "0"))
        .join(""); // convert bytes to hex string
      // console.log('hashHex: ', hashHex)
      return hashHex;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    }
  },
  computed: {
    form() {
      return {
        username: this.username,
        password: this.password
      };
    }
  },
  created() {
    this.handleView();
    this.clearCookie();
    window.addEventListener("resize", this.handleView);
  }
};
</script>

<style>
.loginadminicon .v-input__icon--prepend .v-icon {
  color: #6a7d69;
}
.v-card__text.login2 {
  padding: 0px 16px 0px 16px !important;
}
.rounded-card {
  border-radius: 15px;
}
.loginbtn {
  text-align: center;
  border-radius: 4px;
}
.adminlogo {
  width: 300px;
  margin-bottom: 20px;
}
@media (max-width: 500px) {
  .v-card#loginBox {
    width: 80%;
  }
  img.logoinet {
    width: 180px;
  }
  .btn.loginbtn {
    width: 20%;
  }
  .adminlogo {
    width: 280px;
    /* margin-bottom:100px; */
  }
}
</style>
